#!/usr/bin/env python
import pygame
from pygame.locals import *
from sys import exit
from math import pi
from random import randint

pygame.init()
pygame.joystick.init()

jscount = pygame.joystick.get_count()

if jscount != 4:
	print "You must have 4 joystick devices attached to your computer."
	exit(1)
	
joysticks = []
for x in range(jscount):
	thisjs = pygame.joystick.Joystick(x)
	#if "Microsoft X-Box 360 Big Button IR" in thisjs.get_name():
	#	# this is a controller we want to use
	joysticks.append(thisjs)
	print "- Using joystick %s: %s" % (x, thisjs.get_name())
	thisjs.init()

#if len(joysticks) != 4:
#	print "There needs to be 4 Big Button IR controllers attached."
#	exit(1)

print ""

print "loading audio..."

SOUND = (
	pygame.mixer.Sound("green.ogg"),
	pygame.mixer.Sound("red.ogg"),
	pygame.mixer.Sound("blue.ogg"),
	pygame.mixer.Sound("yellow.ogg"),
	pygame.mixer.Sound("fail.ogg"),
	pygame.mixer.Sound("pass.ogg"),
)

def play_sound(num):
	global SOUND
	SOUND[num].play()
	pygame.time.wait(int(SOUND[num].get_length()*1000))


print "loading main screen..."

screen = pygame.display.set_mode((600,600))
pygame.display.set_caption('simon')
playgame = True

SCREEN_W  = screen.get_width()
SCREEN_H  = screen.get_height()
FIVEPC_W  = int(SCREEN_W*.05)
FIVEPC_H  = int(SCREEN_H*.05)
FORTYPC_W = int(SCREEN_W*.9)
FORTYPC_H = int(SCREEN_H*.9)

WHITE = pygame.Color("#ffffff")
CIRCLE_R = pygame.Rect(FIVEPC_W, FIVEPC_H, FORTYPC_W, FORTYPC_H)
GREEN  = pygame.Color("#00ff00")
RED    = pygame.Color("#ff0000")
BLUE   = pygame.Color("#0000ff")
YELLOW = pygame.Color("#ffff00")

current = [GREEN, RED, BLUE, YELLOW]
original= [GREEN, RED, BLUE, YELLOW]

current_pattern = [randint(0,3)]
current_position = 0
current_demo = True

print "entering event loop."
while playgame:
	if pygame.event.peek():
		for event in pygame.event.get():
			if event.type == QUIT:
				playgame = False
				break
			elif not current_demo: # ignore button presses during demo
				if event.type == JOYBUTTONDOWN:
					print "got button press, joystick=%s, button=%s" % (event.joy, event.button)
					current[event.joy] = WHITE
					play_sound(event.joy)
					
					# determine if it is what should come next
					if current_pattern[current_position] == event.joy:
						# correct!
						current_position += 1
						
						if current_position == len(current_pattern):
							current_demo = True
							current_position = -1
							next = current_pattern[-1]
							while next == current_pattern[-1]:
								next = randint(0,3)
							
							current_pattern.append(next)

							play_sound(5)
					else:
						# incorrect
						print "sorry, player %s made you lose the game" % event.joy
						playgame = False
						pygame.display.flip()
						play_sound(4)
						break
				elif event.type == JOYBUTTONUP:
					print "got button release, joystick=%s, button=%s" % (event.joy, event.button)
					current[event.joy] = original[event.joy]
	
	if playgame:
		
		if current_demo:
			# currently doing a demo
			#if current_position != 0:
			pygame.time.delay(300)
			current = [GREEN, RED, BLUE, YELLOW]

			if current_position == len(current_pattern):
				current_demo = False
				current_position = 0
				print "pattern:"
				print current_pattern
				
			else:
				if current_position != -1:
					current[current_pattern[current_position]] = WHITE
					play_sound(current_pattern[current_position])
				current_position += 1
		else:
			# currently playing the actual game
			pass
		
	
		pygame.draw.arc(screen, current[0], CIRCLE_R, pi*.5,  pi,     5)
		pygame.draw.arc(screen, current[1], CIRCLE_R, 0.,     pi*.5,  5)
		pygame.draw.arc(screen, current[2], CIRCLE_R, pi,     pi*1.5, 5)
		pygame.draw.arc(screen, current[3], CIRCLE_R, pi*1.5, pi*2.,  5)
	
		pygame.event.pump()
		pygame.display.flip()

print "goodbye!"
